package it.unitn.web.protocol;

import java.net.*;
import java.io.*;

/**
  * RequestHandler is a simple implementation of the connection 
  * handler.
  *
  * @version 1.3 07/03/06
  * @author Alexander Ivanyukovich
  */
public class RequestHandler implements Runnable{
  
  private Socket sock = null;

  public RequestHandler(Socket socket){
    sock = socket;
  }

  /**
   * Receives and sends messages from client to protocol implementation and back.
   */
  public void run(){
    PrintWriter out = null;
    BufferedReader in = null;
    try{
      out = new PrintWriter(sock.getOutputStream(), true);
      in = new BufferedReader(new InputStreamReader(sock.getInputStream()));

      String inputLine, outputLine;
      TestProtocol protocol = new TestProtocol();
      out.println("Welcome:");
      while((inputLine = in.readLine()) != null){
        if(inputLine.trim().length() > 0){
          outputLine = protocol.processInput(inputLine.trim());
          if(outputLine != null)
            out.println(outputLine);
          else
            break;
        }
      }
      out.close();
      out = null;
      in.close();
      in = null;
      sock.close();
      sock = null;
    }catch(Exception e){
    }finally{
      if(out != null) try{ out.close(); }catch(Exception e){}
      if(in != null) try{ in.close(); }catch(Exception e){}
      if(sock != null) try{ sock.close(); }catch(Exception e){}
    }
  }
}
