package it.unitn.web.protocol;

import java.io.*;
import java.net.*;
import java.util.concurrent.*;

/**
  * RequestsDispatcher transfers incoming connections requests to 
  * appropriate handlers. Supports multiple connections at the same time
  * (limited by POOL_SIZE).
  *
  * @version 1.2 07/03/06
  * @author Alexander Ivanyukovich
  */
public class RequestsDispatcher{

  public static final File STARTED_FILE = new File("dispatcher.run");
  public static final int SERVER_PORT = 2700;
  public static final int POOL_SIZE = 100;

  public static void main(String[] args){
    final ExecutorService pool = Executors.newFixedThreadPool(POOL_SIZE);
    try{
      STARTED_FILE.createNewFile();
      ServerSocket ssock = new ServerSocket(SERVER_PORT);
      while(STARTED_FILE.exists())
        pool.execute(new RequestHandler(ssock.accept()));
      ssock.close();
    }catch(IOException e){
      System.err.println("Could not bind to port "+SERVER_PORT);
    }catch(Exception e){
      pool.shutdownNow();
    }finally{
      pool.shutdown();
    }
  }
}